(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(*OpenMath Package (c) 2011 Karoly Bosa and Peter Horn.
Licensed under the Apache License,Version 2.0 (the "License");you may not use this file except in compliance with the License. You may obtain a copy of the License at 

http://www.apache.org/licenses/LICENSE-2.0 

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS,WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,either express or implied.See the License for the specific language governing permissions and limitations under the License.*)


BeginPackage["OpenMath`"]


OMObject2XML::usage = "OMObject2XML[O] converts an (internal) OpenMath object tree representation to (string) XML OpenMath format.";
XML2OMObject::usage = "XML2OMObject[X] converts a (string) XML OpenMath representation to (internal) OpenMath object tree format.";
OMObject2Mathematica::usage = "OMObject2Mathematica[O] converts (internal) OpenMath object tree representation to a Mathematica expression.";
Mathematica2OMObject::usage = "Mathematica2OMObject[M] converts a Mathematica expression to (internal) OpenMath object tree.";
Mathematica2XML::usage = "Mathematica2XML[M] converts a Mathematica expression to (string) XML OpenMath format.";
XML2Mathematica::usage = "XML2Mathematica[X] converts a (string) XML OpenMath representation to a Mathematica expression.";


Unprotect[OMApply,OMBinary,OMBind,OMError,OMFloat,OMForeign,OMInteger,OMObject,OMReference,OMString,OMSymbol,OMVariable];
Clear[OMApply,OMBinary,OMBind,OMError,OMFloat,OMForeign,OMInteger,OMObject,OMReference,OMString,OMSymbol,OMVariable];
OMApply=OMApply;OMBinary=OMBinary;OMBind=OMBind;OMError=OMError;OMFloat=OMFloat;OMForeign=OMForeign;OMInteger=OMInteger;OMObject=OMObject;OMReference=OMReference;OMString=OMString;OMSymbol=OMSymbol;OMVariable=OMVariable;
Protect[OMApply,OMBinary,OMBind,OMError,OMFloat,OMForeign,OMInteger,OMObject,OMReference,OMString,OMSymbol,OMVariable]


Begin["`Private`"]


CDs = {"Arith1","Integer1","Transc1","Logic1","List1","Minmax1", "Nums1", "Relation1","Set1","Setname1"}; (* Including new CD: You must add the name of the new CD package to this list. That's it.*)
For[i=1, i<=Length[CDs],i++,
Needs[CDs[[i]]<>"`"];
Print["OpenMath Contect Dictionary "<>CDs[[i]]<>" is loaded."]
]


OMPhrasebook = Map[Expand, Map[ToExpression, CDs]]


OM2Mathematica=Flatten[
Map[
Function[cd, 
Map[
Function[r,
OMSymbol[cd[[1]], r[[1]]] -> r[[2]]
], 
cd[[2]]
]
],
OMPhrasebook]
];


Mathematica2OM = Map[(#[[2]]-> #[[1]])&, OM2Mathematica];


Clear[Xp];
Xp[OMApply[head_, params_]] := XMLElement["OMA", {}, Join[{Xp[head]},Xp/@params]];Xp[OMBinary[payload_]] := XMLElement["OMB", {}, {payload}];Xp[OMBind[symbol_, vars_, expr_]] := XMLElement["OMBIND", {}, {symbol, vars, expr}];Xp[OMError[head_, params_]] := XMLElement["OME", {}, Join[{Xp[head]},Xp/@params]];Xp[OMFloat[float_]] := XMLElement["OMF", {"dec"-> float}, {}];Xp[OMForeign[payload_]] := XMLElement["OMFOREIGN", {}, {payload}];
Xp[OMInteger[int_]] := XMLElement["OMI", {}, {ToString[int]}];
Xp[OMObject[obj_]] := XMLElement["OMOBJ", {}, {Xp[obj]}];
Xp[OMReference[href_]] := XMLElement["OMR", {"href"-> href},{}];
Xp[OMString[str_]] := XMLElement["OMSTR", {}, {str}];
Xp[OMSymbol[cd_, name_]] := XMLElement["OMS", {"cd"-> cd, "name"-> name}, {}];
Xp[OMVariable[name_]] := XMLElement["OMV", {"name"-> name},{}];
OMObject2XML[O_] := ExportString[Xp[O], "XML"];


OMObject2Mathematica[symb_OMSymbol] := symb/. OM2Mathematica;
OMObject2Mathematica[OMInteger[int_]] := ToExpression[int];
OMObject2Mathematica[OMApply[head_, params_]] := OMObject2Mathematica[head]@@(OMObject2Mathematica/@params);
OMObject2Mathematica[OMFloat[float_]] := ToExpression[float];
OMObject2Mathematica[OMString[str_]] := ToString[str];
OMObject2Mathematica[OMObject[obj_]] := OMObject2Mathematica[obj];
OMObject2Mathematica[OMVariable[nam_]] :=Symbol[nam];


Math2OM[int_Integer] := OMInteger[int];
Math2OM[sym_Symbol] := Module[{lok}, 
lok = sym /. Mathematica2OM;
If [TrueQ[Head[lok]==OMSymbol], 
lok, 
OMVariable[ToString[sym]]
]
];
Math2OM[f_[x___]] := OMApply[Math2OM[f], Map[Mathematica2OMObject, Map[Unevaluated, Unevaluated[{x}]]]];


OpenMath[XMLObject["Document"][{},om_,{}]] := OpenMath[om];
OpenMath[XMLElement["OMA", {}, params_]]:=OMApply[OpenMath[First[params]], OpenMath/@Rest[params]];
OpenMath[XMLElement["OMB", {}, {bytes_}]] := OMBinary[bytes];OpenMath[XMLElement["OMBIND", {}, {symbol_, XMLElement["OMBVARS", {},bvars_], param_}]]:= OMBind[OpenMath[symbol], OpenMath/@bvars , OpenMath[param]];
OpenMath[XMLElement["OME", {}, params_]]:=OMError[OpenMath[First[params], OpenMath/@Rest[params]]];
OpenMath[XMLElement["OMFOREIGN", {}, {data_}]] := OMForeign[data];
OpenMath[XMLElement["OMI", {}, {int_}]] := OMInteger[ToExpression[int]];
OpenMath[XMLElement["OMOBJ", {}, {om_}]] := OMObject[OpenMath[om]];
OpenMath[XMLElement["OMR", n_, x_]] := OMReference["href"/.n];
OpenMath[XMLElement["OMSTR", {}, {str_}]] := OMString[ToString[str]];
OpenMath[XMLElement["OMS", n_, x_]] := OMSymbol[Sequence@@({"cd", "name"}/.n)];
OpenMath[XMLElement["OMV", n_, x_]] := OMVariable["name"/.n];


MathString2OMObject[s_String] := Module[{expr},
expr = ToExpression[s, InputForm];
Apply[Math2OM, expr]
]


Mathematica2OMObject[expr_] := Module[{s, e},
If[MatchQ[Unevaluated[expr], _Symbol],
If[MatchQ[expr, _Hold],
s = ToString[ReleaseHold[Unevaluated[expr]], InputForm];MathString2OMObject[s],
Math2OM[Evaluate[expr]]
],
s = ToString[Hold[expr], InputForm];MathString2OMObject[s]
]
]


XML2OMObject[s_String] := OpenMath[ImportString[s,"XML"]];


Mathematica2XML[M_] := OMObject2XML[Mathematica2OMObject[Unevaluated[M]]];
XML2Mathematica[X_] := OMObject2Mathematica[XML2OMObject[X]];
SetAttributes[Math2OM, HoldAll];
SetAttributes[Mathematica2OMObject, HoldFirst];
SetAttributes[Mathematica2XML, HoldFirst];


Protect[OMObject2XML, XML2OMObject, OMObject2Mathematica, Mathematica2OMObject, Mathematica2XML, XML2Mathematica];


End[]


EndPackage[]
