(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(*SCSCP Package (c) 2011 Karoly Bosa and Peter Horn. Licensed under the Apache License,Version 2.0 (the "License");
you may not use this file except in compliance with the License.You may obtain a copy of the License at 
http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing,software distributed under the License is distributed on an "AS IS" BASIS,WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,either express or implied.See the License for the specific language governing permissions and limitations under the License.*)


BeginPackage["SCSCP`"]


(* ::Input:: *)
OMObject2Java::usage = "OMObject2Java[O] converts an (internal) OpenMath object tree representation to Symcomp java OpenMath representation.";
SCSCPInit::usage = "SCSCPInit[path] sets the location of SCSCP4Mathematica.jar in the classpath. The default location is '.' .";
SCSCPConnectionInit::usage = "SCSCPConnectionInit[server, port] initializes a connection (opens a socket to the given SCSCP server).";
SCSCPConnectionClose::usage = "SCSCPConnectionClose[connection] closes the given connection (and the socket).";
SCSCPComputeBlocking::usage = "SCSCPComputeBlocking[expr, service, connection] converts a Mathematica expression into OpenMath format and sends it to an SCSCP server. It blocks until the result is available, then returns with it. Service denotes the name of the service which will be use on the SCSCP server.";
SCSCPCompute::usage = "SCSCPCompute[expr, service, connection] converts a Mathematica expression into OpenMath format and sends it to an SCSCP server, then it returns immediately. Service denotes the name of the service which will be use on the SCSCP server.";
SCSCPWait::usage = "SCSCPWait[token] blocks until the result of the computation identified by token is available and returns with it.";
SCSCPProbe::usage = "SCSCPProbe[token] returns with the state of the computation identified by the token"
SCSCPComputeXMLBlocking::usage = "SCSCPComputeXMLBlocking[expr, connection] sends an xml-based OpenMath expression to an SCSCP server. It blocks until the result is available, then returns with it.";
SCSCPComputeXML::usage = "SCSCPComputeXML[expr, connection]  sends an xml-based OpenMath expression to an SCSCP server, then it returns immediately.";
StartSCSCPServer::usage = "SCSCPServer[port, logLevel] starts a server which listening for client connections on the given port. Events are logged with given logLevel(from 1 to 5).";
SCSCPRequestEvaluation::usage = "SCSCPRequestEvaluation is called by Java server.";


Begin["`Private`"]


Needs["JLink`"]


Needs["OpenMath`"]


SCSCP`Initialized = False
ListOfConnections = {}


SCSCPInit[] := SCSCPInit["."]


SCSCPInit[path_String] := Module[{cp},
cp = path<>"/SCSCP4Mathematica.jar";
 ReinstallJava[ClassPath-> cp];
LoadJavaClass["org.symcomp.mathematica.MathServer"];
LoadJavaClass["org.symcomp.scscp.ComputationState"];
SCSCP`Initialized = True;
Print["Classpath: "<>cp];
]



SCSCPConnectionInit[server_, port_] := Module[{jclient},
If[SCSCP`Initialized == True,
jclient = JavaNew["org.symcomp.scscp.SCSCPClient", server, port ];
AppendTo[ListOfConnections, {jclient, server, port}];
jclient,
Print["The SCSCP package was not initialized!"]]
]


SCSCPConnectionClose[jclient_] := Module[{conn},
If[SCSCP`Initialized == True,
For[i = 1, i<=Length[ListOfConnections], i++,
conn = ListOfConnections[[i]];
If[conn[[1]] == jclient,
Print["Connection was closed with the server "<>conn[[2]]<>":"<>conn[[3]]];
Break[],
Null]
];
jclient@quit[],
Print["The SCSCP package was not initialized!"]]
]


AddOMHeader[OM_, service_String] := OMApply[OMSymbol["scscp_transient_1", service], {OM}]


Clear[Jv];
Jv[OMApply[head_,params_]]:=JavaNew["org.symcomp.openmath.OMApply",Jv[head],ReturnAsJavaObject[Fold[ReturnAsJavaObject[#1@add[Jv[#2]]]&,JavaNew["org.symcomp.openmath.OMList"],params]@array[] ]];
Jv[OMBinary[payload_]]:=JavaNew["org.symcomp.openmath.OMBinary",payload];
Jv[OMBind[symbol_,vars_,expr_]]:=JavaNew["org.symcomp.openmath.OMBind",Jv[symbol],Jv[vars],Jv[expr]];
Jv[OMError[head_,params_]]:=JavaNew["org.symcomp.openmath.OMErrdist`or",Jv[head],ReturnAsJavaObject[Fold[ReturnAsJavaObject[#1@add[Jv[#2]]]&,JavaNew["org.symcomp.openmath.OMList"],params]@array[] ]];
Jv[OMFloat[float_]]:=JavaNew["org.symcomp.openmath.OMFloat",float];
Jv[OMForeign[payload_]]:=JavaNew["org.symcomp.openmath.OMForeign",payload];
Jv[OMInteger[int_]]:=JavaNew["org.symcomp.openmath.OMInteger",int];
Jv[OMObject[obj_]]:=JavaNew["org.symcomp.openmath.OMObject",Jv[obj]];
Jv[OMReference[href_]]:=JavaNew["org.symcomp.openmath.OMReference",href];
Jv[OMString[str_]]:=JavaNew["org.symcomp.openmath.OMString",str];
Jv[OMSymbol[cd_,name_]]:=JavaNew["org.symcomp.openmath.OMSymbol",cd,name];
Jv[OMVariable[name_]]:=JavaNew["org.symcomp.openmath.OMVariable",name]


OMObject2Java[OM_] := Jv[OM];


SCSCPComputeBlocking[expr_, service_String,jclient_] := Module[{jin, jout, OMTree,OMWithHeader, conn},
If[SCSCP`Initialized == True,
For[i = 1, i<=Length[ListOfConnections], i++,
conn = ListOfConnections[[i]];
If[conn[[1]] == jclient,
Print["Expression \""<>ToString[Unevaluated[expr], InputForm]<>"\" is sent to the SCSCP server "<>conn[[2]]<>":"<>conn[[3]]<>"." ];
Break[],
Null]
];
OMTree = Mathematica2OMObject[Unevaluated[expr]];
If[service=="",
OMWithHeader = OMTree,
OMWithHeader = AddOMHeader[OMTree, service]
];
Print["------------------------------------------"];
Print[OMObject2XML[OMWithHeader]];
Print["------------------------------------------"];
jin = OMObject2Java[OMWithHeader]; (*org`sympcomp`openmath`OpenMathBase`parseXml (Mathematica2XML (expr))<--NOT WORKING*)
Print["Waiting for the answer..."];
jout = jclient@computeBlocking[jin];
XML2Mathematica[jout@toXml[]],
Print["The SCSCP package was not initialized!"]
]
]


SCSCPCompute[expr_, service_String,jclient_] := Module[{jin, OMTree,OMWithHeader, conn},
If[SCSCP`Initialized == True,
For[i = 1, i<=Length[ListOfConnections], i++,
conn = ListOfConnections[[i]];
If[conn[[1]] == jclient,
Print["Expression \""<>ToString[Unevaluated[expr], InputForm]<>"\" is sent to the SCSCP server "<>conn[[2]]<>":"<>conn[[3]]<>"." ];
Break[],
Null]
];
OMTree = Mathematica2OMObject[Unevaluated[expr]];
If[service=="",
OMWithHeader = OMTree,
OMWithHeader = AddOMHeader[OMTree, service]
];
Print["------------------------------------------"];
Print[OMObject2XML[OMWithHeader]];
Print["------------------------------------------"];
jin = OMObject2Java[OMWithHeader]; (*org`sympcomp`openmath`OpenMathBase`parseXml (Mathematica2XML (expr))<--NOT WORKING*)
jclient@compute[jin],
Print["The SCSCP package was not initialized!"]
]
]


SCSCPProbe[token_String, jclient_] := Module[{state},
If[SCSCP`Initialized = True,
state = jclient@getResult[token];
state = jclient@getComputationState[token];
Which[
state== org`symcomp`scscp`ComputationState`WAITING, "WAITING",
state== org`symcomp`scscp`ComputationState`COMPUTING, "COMPUTING",
state== org`symcomp`scscp`ComputationState`READY, "READY",
state== org`symcomp`scscp`ComputationState`ERRONEOUS, "ERRONEOUS"],
Print["The SCSCP package was not initialized!"]]
]


SCSCPWait[token_String, jclient_] := Module[{jout},
If[SCSCP`Initialized = True,
While[!jclient@resultAvailable[token],
Pause[2]
];
jout= jclient@getResult[token];
XML2Mathematica[jout@toXml[]],
Print["The SCSCP package was not initialized!"]]
]


SetAttributes[SCSCPComputeBlocking, HoldFirst];
SetAttributes[SCSCPCompute, HoldFirst];
SetAttributes[AddOMHeader,HoldFirst];
SetAttributes[OMObject2Java,HoldFirst];


StartSCSCPServer[port_, logLevel_] := Module[{},
If[SCSCP`Initialized == True ,
If[logLevel>=0 || logLevel<=5,
org`symcomp`mathematica`MathServer`startMathServer[port, logLevel],
Print["Incorrect logging level!"]
],
Print["The SCSCP package was not initialized!"]]
]


SCSCPRequestEvaluation[xin_String] := Module[{expr, jout},
expr = XML2Mathematica[xin];
jout = OMObject2Java[Mathematica2OMObject[Evaluate[expr]]]
]


SCSCPComputeXMLBlocking[xml_String,jclient_] := Module[{jin, jout, OMTree,OMWithHeader, conn},
If[SCSCP`Initialized == True,
For[i = 1, i<=Length[ListOfConnections], i++,
conn = ListOfConnections[[i]];
If[conn[[1]] == jclient,
Print["Expression \""<>xml<>"\" is sent to the SCSCP server "<>conn[[2]]<>":"<>conn[[3]]<>"." ];
Break[],
Null]
];
OMTree = XML2OMObject[xml];
jin = OMObject2Java[OMTree];  
Print["Waiting for the answer..."];
jout = jclient@computeBlocking[jin];
XML2Mathematica[jout@toXml[]],
Print["The SCSCP package was not initialized!"]
]
]

SCSCPComputeXML[xml_String, jclient_] := Module[{jin, OMTree,OMWithHeader, conn},
If[SCSCP`Initialized == True,
For[i = 1, i<=Length[ListOfConnections], i++,
conn = ListOfConnections[[i]];
If[conn[[1]] == jclient,
Print["Expression \""<>xml<>"\" is sent to the SCSCP server "<>conn[[2]]<>":"<>conn[[3]]<>"." ];
Break[],
Null]
];
OMTree = XML2OMObject[xml];
jin = OMObject2Java[OMTree];
jclient@compute[jin],
Print["The SCSCP package was not initialized!"]
]
]


Protect[OMObject2Java, SCSCPInit, SCSCPConnectionInit, SCSCPConnectionClose, SCSCPComputeBlocking, SCSCPCompute, SCSCPWait, SCSCPProbe, StartSCSCPServer, SCSCPRequestEvaluation, SCSCPComputeXMLBlocking, SCSCPComputeXML];


End[]


EndPackage[]
