package org.symcomp.mathematica;

import org.symcomp.scscp.*;

@SCSCPServerInfo(serviceName="JavaMathematicaServer", serviceVersion="1.0.0", serviceDescription="Mathematica Server")
public class MathServer extends SCSCPServer {

    public MathServer(String serviceId, java.io.PrintWriter out, java.io.BufferedReader inn) {
        super(MathServer.class, serviceId, out, inn);
        this.addHandler(new MathematicaHandler());
        //this.addHandler(new AdditionHandler());
	System.out.println("MathServer started.");
    }

    public static void startMathServer(int port, int logLevel) throws Exception {
        org.symcomp.scscp.SCSCPServer.setLoglevel(logLevel);
        MathServer.spawn(MathServer.class, port); //non-blocking
    }

    public static void main(String[] args) throws Exception {
        if (args.length < 1) return;
        int port = Integer.parseInt(args[0]);
        startMathServer(port, 4); 
    }
}
