package org.symcomp.mathematica;

import org.symcomp.scscp.*;
import org.symcomp.openmath.*;
import com.wolfram.jlink.*;

public class MathematicaHandler extends ProcedureCallHandler {
	public String getServiceNameStr() { return "mathematica"; }
	public String getDescription(OMSymbol oms) { return "Expressions are evaluated in Mathematica kernel."; }

	public OpenMathBase handlePayload(OpenMathBase omb) throws OpenMathException
	{
		//OMB contains the actual call to addition as 1st argument, so we bypass that.
                OpenMathBase[] apps = ((OMApply) omb).getParams();
                StringBuffer strIn = new StringBuffer();
                for (int i=0; i<apps.length; i++) {
                    strIn.append(apps[i].toXml());
                }
                OpenMathBase res;
		try {
                     KernelLink link = StdLink.getLink();
                     if (link != null) {
                       link.putFunction("EvaluatePacket", 1);
                       link.putFunction("SCSCPRequestEvaluation", 1);
                       link.put(strIn.toString()); 
                       link.endPacket();
                       link.waitForAnswer();
                       res = (OpenMathBase) link.getObject();
                       System.out.println("============================");
                       System.out.println(res.toXml());
                       System.out.println("============================");
                       return res;
                    }
                }   catch(MathLinkException e) {}
                System.out.println("EZ NEM JO!!!");
                return omb;
	}
}
