(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     27868,        805]
NotebookOptionsPosition[     26083,        742]
NotebookOutlinePosition[     26453,        758]
CellTagsIndexPosition[     26410,        755]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["OpenMath Package", "Title",
 CellChangeTimes->{{3.512387633856276*^9, 3.512387641132042*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"OpenMath", " ", "Package", " ", 
    RowBox[{"(", "c", ")"}], " ", "2011", " ", "Karoly", " ", "Bosa", " ", 
    "and", " ", "Peter", " ", 
    RowBox[{"Horn", ".", "\n", "Licensed"}], " ", "under", " ", "the", " ", 
    "Apache", " ", "License"}], ",", 
   RowBox[{
    RowBox[{"Version", " ", "2.0", " ", 
     RowBox[{"(", 
      RowBox[{"the", " ", "\"\<License\>\""}], ")"}]}], ";", 
    RowBox[{
     RowBox[{
     "you", " ", "may", " ", "not", " ", "use", " ", "this", " ", "file", " ",
       "except", " ", "in", " ", "compliance", " ", "with", " ", "the", " ", 
      RowBox[{"License", ".", " ", "You"}], " ", "may", " ", "obtain", " ", 
      "a", " ", "copy", " ", "of", " ", "the", " ", "License", " ", "at", " ",
       "\n", "\n", 
      RowBox[{"http", ":"}]}], "//", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"www", ".", "apache", ".", "org"}], "/", "licenses"}], "/", 
       "LICENSE"}], "-", 
      RowBox[{
      "2.0", " ", "\n", "\n", "Unless", " ", "required", " ", "by", " ", 
       "applicable", " ", "law", " ", "or", " ", "agreed", " ", "to", " ", 
       "in", " ", "writing"}]}]}]}], ",", " ", 
   RowBox[{
   "software", " ", "distributed", " ", "under", " ", "the", " ", "License", 
    " ", "is", " ", "distributed", " ", "on", " ", "an", " ", "\"\<AS IS\>\"",
     " ", "BASIS"}], ",", 
   RowBox[{
   "WITHOUT", " ", "WARRANTIES", " ", "OR", " ", "CONDITIONS", " ", "OF", " ",
     "ANY", " ", "KIND"}], ",", 
   RowBox[{"either", " ", "express", " ", "or", " ", 
    RowBox[{"implied", ".", "See"}], " ", "the", " ", "License", " ", "for", 
    " ", "the", " ", "specific", " ", "language", " ", "governing", " ", 
    "permissions", " ", "and", " ", "limitations", " ", "under", " ", "the", 
    " ", 
    RowBox[{"License", "."}]}]}], "*)"}]], "Code"],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<OpenMath`\>\"", "]"}]], "Code"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2XML", "::", "usage"}], " ", "=", " ", 
   "\"\<OMObject2XML[O] converts an (internal) OpenMath object tree \
representation to (string) XML OpenMath format.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"XML2OMObject", "::", "usage"}], " ", "=", " ", 
   "\"\<XML2OMObject[X] converts a (string) XML OpenMath representation to \
(internal) OpenMath object tree format.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Mathematica", "::", "usage"}], " ", "=", " ", 
   "\"\<OMObject2Mathematica[O] converts (internal) OpenMath object tree \
representation to a Mathematica expression.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Mathematica2OMObject", "::", "usage"}], " ", "=", " ", 
   "\"\<Mathematica2OMObject[M] converts a Mathematica expression to \
(internal) OpenMath object tree.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Mathematica2XML", "::", "usage"}], " ", "=", " ", 
   "\"\<Mathematica2XML[M] converts a Mathematica expression to (string) XML \
OpenMath format.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"XML2Mathematica", "::", "usage"}], " ", "=", " ", 
   "\"\<XML2Mathematica[X] converts a (string) XML OpenMath representation to \
a Mathematica expression.\>\""}], ";"}]}], "Code",
 CellChangeTimes->{{3.512388855045152*^9, 3.512389028986259*^9}, {
  3.512389061379615*^9, 3.512389069914911*^9}, {3.51245350887602*^9, 
  3.512453638897748*^9}, {3.51245610799377*^9, 3.512456117599179*^9}, {
  3.512456533798309*^9, 3.512456537922723*^9}}],

Cell[CellGroupData[{

Cell["Basic Datatypes", "Subsection",
 CellChangeTimes->{{3.512387690299136*^9, 3.512387695751225*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{
   "OMApply", ",", "OMBinary", ",", "OMBind", ",", "OMError", ",", "OMFloat", 
    ",", "OMForeign", ",", "OMInteger", ",", "OMObject", ",", "OMReference", 
    ",", "OMString", ",", "OMSymbol", ",", "OMVariable"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{
   "OMApply", ",", "OMBinary", ",", "OMBind", ",", "OMError", ",", "OMFloat", 
    ",", "OMForeign", ",", "OMInteger", ",", "OMObject", ",", "OMReference", 
    ",", "OMString", ",", "OMSymbol", ",", "OMVariable"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"OMApply", "=", "OMApply"}], ";", 
  RowBox[{"OMBinary", "=", "OMBinary"}], ";", 
  RowBox[{"OMBind", "=", "OMBind"}], ";", 
  RowBox[{"OMError", "=", "OMError"}], ";", 
  RowBox[{"OMFloat", "=", "OMFloat"}], ";", 
  RowBox[{"OMForeign", "=", "OMForeign"}], ";", 
  RowBox[{"OMInteger", "=", "OMInteger"}], ";", 
  RowBox[{"OMObject", "=", "OMObject"}], ";", 
  RowBox[{"OMReference", "=", "OMReference"}], ";", 
  RowBox[{"OMString", "=", "OMString"}], ";", 
  RowBox[{"OMSymbol", "=", "OMSymbol"}], ";", 
  RowBox[{"OMVariable", "=", "OMVariable"}], ";"}], "\n", 
 RowBox[{"Protect", "[", 
  RowBox[{
  "OMApply", ",", "OMBinary", ",", "OMBind", ",", "OMError", ",", "OMFloat", 
   ",", "OMForeign", ",", "OMInteger", ",", "OMObject", ",", "OMReference", 
   ",", "OMString", ",", "OMSymbol", ",", "OMVariable"}], "]"}]}], "Code",
 CellChangeTimes->{3.512453466242052*^9}],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Converison Rules", "Subsection",
 CellChangeTimes->{{3.51238797902851*^9, 3.512387982086054*^9}}],

Cell[CellGroupData[{

Cell["\<\
Loading Available Conversion Rules from Content Dictionary To Mathematica \
\>", "Subsubsection",
 CellChangeTimes->{{3.512387827477198*^9, 3.512387905714004*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CDs", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
    "\"\<Arith1\>\"", ",", "\"\<Integer1\>\"", ",", "\"\<Transc1\>\"", ",", 
     "\"\<Logic1\>\"", ",", "\"\<List1\>\"", ",", "\"\<Minmax1\>\"", ",", 
     " ", "\"\<Nums1\>\"", ",", " ", "\"\<Relation1\>\"", ",", "\"\<Set1\>\"",
      ",", "\"\<Setname1\>\""}], "}"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"Including", " ", "new", " ", 
    RowBox[{"CD", ":", " ", 
     RowBox[{
     "You", " ", "must", " ", "add", " ", "the", " ", "name", " ", "of", " ", 
      "the", " ", "new", " ", "CD", " ", "package", " ", "to", " ", "this", 
      " ", 
      RowBox[{"list", ".", " ", 
       RowBox[{"That", "'"}]}], "s", " ", 
      RowBox[{"it", "."}]}]}]}], "*)"}], "\n", 
  RowBox[{"For", "[", 
   RowBox[{
    RowBox[{"i", "=", "1"}], ",", " ", 
    RowBox[{"i", "<=", 
     RowBox[{"Length", "[", "CDs", "]"}]}], ",", 
    RowBox[{"i", "++"}], ",", "\n", 
    RowBox[{
     RowBox[{"Needs", "[", 
      RowBox[{
       RowBox[{"CDs", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "<>", "\"\<`\>\""}], "]"}], ";", "\n", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<OpenMath Contect Dictionary \>\"", "<>", 
       RowBox[{"CDs", "[", 
        RowBox[{"[", "i", "]"}], "]"}], "<>", "\"\< is loaded.\>\""}], 
      "]"}]}]}], "\n", "]"}]}]], "Code",
 CellChangeTimes->{{3.512312765574848*^9, 3.512312831581044*^9}, {
  3.512314127668382*^9, 3.512314180585417*^9}, {3.512315080974356*^9, 
  3.512315085676848*^9}, {3.51237662618934*^9, 3.512376631507172*^9}, {
  3.512379257023488*^9, 3.512379260370389*^9}, {3.51238096322822*^9, 
  3.51238096913666*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Translation Table/PhraseBook", "Subsubsection",
 CellChangeTimes->{{3.512388042525729*^9, 3.512388053449586*^9}}],

Cell[BoxData[
 RowBox[{"OMPhrasebook", " ", "=", " ", 
  RowBox[{"Map", "[", 
   RowBox[{"Expand", ",", " ", 
    RowBox[{"Map", "[", 
     RowBox[{"ToExpression", ",", " ", "CDs"}], "]"}]}], "]"}]}]], "Code",
 CellChangeTimes->{{3.512309551273711*^9, 3.512309575849343*^9}, {
  3.512309614283262*^9, 3.512309631234063*^9}, {3.512309670697085*^9, 
  3.512309697061497*^9}, {3.512309750497762*^9, 3.512309751018481*^9}, {
  3.512309925957263*^9, 3.512309938818355*^9}, {3.512310092056336*^9, 
  3.512310102467496*^9}, {3.512310902915969*^9, 3.512310905527344*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"OM2Mathematica", "=", 
   RowBox[{"Flatten", "[", "\n", 
    RowBox[{"Map", "[", "\n", 
     RowBox[{
      RowBox[{"Function", "[", 
       RowBox[{"cd", ",", " ", "\n", 
        RowBox[{"Map", "[", "\n", 
         RowBox[{
          RowBox[{"Function", "[", 
           RowBox[{"r", ",", "\n", 
            RowBox[{
             RowBox[{"OMSymbol", "[", 
              RowBox[{
               RowBox[{"cd", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
               RowBox[{"r", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}], " ", "->", " ", 
             RowBox[{"r", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}]}], "\n", "]"}], ",", " ", "\n", 
          RowBox[{"cd", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], "\n", "]"}]}], "\n", "]"}], ",", 
      "\n", "OMPhrasebook"}], "]"}], "\n", "]"}]}], ";"}]], "Code"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Mathematica2OM", " ", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "2", "]"}], "]"}], "->", " ", 
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "&"}], ",", " ", 
     "OM2Mathematica"}], "]"}]}], ";"}]], "Code"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Convert OpenMath Object Tree to XML", "Subsection",
 CellChangeTimes->{{3.512388080046329*^9, 3.512388101546453*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "Xp", "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMApply", "[", 
     RowBox[{"head_", ",", " ", "params_"}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMA\>\"", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Xp", "[", "head", "]"}], "}"}], ",", 
       RowBox[{"Xp", "/@", "params"}]}], "]"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMBinary", "[", "payload_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMB\>\"", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"{", "payload", "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMBind", "[", 
     RowBox[{"symbol_", ",", " ", "vars_", ",", " ", "expr_"}], "]"}], "]"}], 
   " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMBIND\>\"", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"symbol", ",", " ", "vars", ",", " ", "expr"}], "}"}]}], 
    "]"}]}], ";", 
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMError", "[", 
     RowBox[{"head_", ",", " ", "params_"}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OME\>\"", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"Xp", "[", "head", "]"}], "}"}], ",", 
       RowBox[{"Xp", "/@", "params"}]}], "]"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMFloat", "[", "float_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMF\>\"", ",", " ", 
     RowBox[{"{", 
      RowBox[{"\"\<dec\>\"", "->", " ", "float"}], "}"}], ",", " ", 
     RowBox[{"{", "}"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMForeign", "[", "payload_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMFOREIGN\>\"", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"{", "payload", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMInteger", "[", "int_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMI\>\"", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"ToString", "[", "int", "]"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMObject", "[", "obj_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMOBJ\>\"", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"Xp", "[", "obj", "]"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMReference", "[", "href_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMR\>\"", ",", " ", 
     RowBox[{"{", 
      RowBox[{"\"\<href\>\"", "->", " ", "href"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMString", "[", "str_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMSTR\>\"", ",", " ", 
     RowBox[{"{", "}"}], ",", " ", 
     RowBox[{"{", "str", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMSymbol", "[", 
     RowBox[{"cd_", ",", " ", "name_"}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMS\>\"", ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\"\<cd\>\"", "->", " ", "cd"}], ",", " ", 
       RowBox[{"\"\<name\>\"", "->", " ", "name"}]}], "}"}], ",", " ", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Xp", "[", 
    RowBox[{"OMVariable", "[", "name_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"XMLElement", "[", 
    RowBox[{"\"\<OMV\>\"", ",", " ", 
     RowBox[{"{", 
      RowBox[{"\"\<name\>\"", "->", " ", "name"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2XML", "[", "O_", "]"}], " ", ":=", " ", 
   RowBox[{"ExportString", "[", 
    RowBox[{
     RowBox[{"Xp", "[", "O", "]"}], ",", " ", "\"\<XML\>\""}], "]"}]}], 
  ";"}]}], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Convert OpenMath Object Tree to ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Expression"
}], "Subsection",
 CellChangeTimes->{{3.512388139620257*^9, 3.512388154856909*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Mathematica", "[", "symb_OMSymbol", "]"}], " ", ":=", 
   " ", 
   RowBox[{"symb", "/.", " ", "OM2Mathematica"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Mathematica", "[", 
    RowBox[{"OMInteger", "[", "int_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"ToExpression", "[", "int", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Mathematica", "[", 
    RowBox[{"OMApply", "[", 
     RowBox[{"head_", ",", " ", "params_"}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{"OMObject2Mathematica", "[", "head", "]"}], "@@", 
    RowBox[{"(", 
     RowBox[{"OMObject2Mathematica", "/@", "params"}], ")"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Mathematica", "[", 
    RowBox[{"OMFloat", "[", "float_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"ToExpression", "[", "float", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Mathematica", "[", 
    RowBox[{"OMString", "[", "str_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"ToString", "[", "str", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Mathematica", "[", 
    RowBox[{"OMObject", "[", "obj_", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"OMObject2Mathematica", "[", "obj", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Mathematica", "[", 
    RowBox[{"OMVariable", "[", "nam_", "]"}], "]"}], " ", ":=", 
   RowBox[{"Symbol", "[", "nam", "]"}]}], ";"}]}], "Code"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Convert ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Expression to OpenMath Object Tree"
}], "Subsection",
 CellChangeTimes->{{3.512388277051383*^9, 3.51238829122953*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Math2OM", "[", "int_Integer", "]"}], " ", ":=", " ", 
   RowBox[{"OMInteger", "[", "int", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Math2OM", "[", "sym_Symbol", "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "lok", "}"}], ",", " ", "\n", 
     RowBox[{
      RowBox[{"lok", " ", "=", " ", 
       RowBox[{"sym", " ", "/.", " ", "Mathematica2OM"}]}], ";", "\n", 
      RowBox[{"If", " ", "[", 
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"Head", "[", "lok", "]"}], "==", "OMSymbol"}], "]"}], ",", 
        " ", "\n", "lok", ",", " ", "\n", 
        RowBox[{"OMVariable", "[", 
         RowBox[{"ToString", "[", "sym", "]"}], "]"}]}], "\n", "]"}]}]}], 
    "\n", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Math2OM", "[", 
    RowBox[{"f_", "[", "x___", "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"OMApply", "[", 
    RowBox[{
     RowBox[{"Math2OM", "[", "f", "]"}], ",", " ", 
     RowBox[{"Map", "[", 
      RowBox[{"Mathematica2OMObject", ",", " ", 
       RowBox[{"Map", "[", 
        RowBox[{"Unevaluated", ",", " ", 
         RowBox[{"Unevaluated", "[", 
          RowBox[{"{", "x", "}"}], "]"}]}], "]"}]}], "]"}]}], "]"}]}], 
  ";"}]}], "Code",
 CellChangeTimes->{3.512388199733478*^9, 3.512388249734153*^9, 
  3.512389673389336*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Convert XML to OpenMath Object Tree", "Subsection",
 CellChangeTimes->{{3.512388221329758*^9, 3.512388234679016*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{
     RowBox[{"XMLObject", "[", "\"\<Document\>\"", "]"}], "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", "om_", ",", 
      RowBox[{"{", "}"}]}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"OpenMath", "[", "om", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMA\>\"", ",", " ", 
      RowBox[{"{", "}"}], ",", " ", "params_"}], "]"}], "]"}], ":=", 
   RowBox[{"OMApply", "[", 
    RowBox[{
     RowBox[{"OpenMath", "[", 
      RowBox[{"First", "[", "params", "]"}], "]"}], ",", " ", 
     RowBox[{"OpenMath", "/@", 
      RowBox[{"Rest", "[", "params", "]"}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMB\>\"", ",", " ", 
      RowBox[{"{", "}"}], ",", " ", 
      RowBox[{"{", "bytes_", "}"}]}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"OMBinary", "[", "bytes", "]"}]}], ";", 
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMBIND\>\"", ",", " ", 
      RowBox[{"{", "}"}], ",", " ", 
      RowBox[{"{", 
       RowBox[{"symbol_", ",", " ", 
        RowBox[{"XMLElement", "[", 
         RowBox[{"\"\<OMBVARS\>\"", ",", " ", 
          RowBox[{"{", "}"}], ",", "bvars_"}], "]"}], ",", " ", "param_"}], 
       "}"}]}], "]"}], "]"}], ":=", " ", 
   RowBox[{"OMBind", "[", 
    RowBox[{
     RowBox[{"OpenMath", "[", "symbol", "]"}], ",", " ", 
     RowBox[{"OpenMath", "/@", "bvars"}], " ", ",", " ", 
     RowBox[{"OpenMath", "[", "param", "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OME\>\"", ",", " ", 
      RowBox[{"{", "}"}], ",", " ", "params_"}], "]"}], "]"}], ":=", 
   RowBox[{"OMError", "[", 
    RowBox[{"OpenMath", "[", 
     RowBox[{
      RowBox[{"First", "[", "params", "]"}], ",", " ", 
      RowBox[{"OpenMath", "/@", 
       RowBox[{"Rest", "[", "params", "]"}]}]}], "]"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMFOREIGN\>\"", ",", " ", 
      RowBox[{"{", "}"}], ",", " ", 
      RowBox[{"{", "data_", "}"}]}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"OMForeign", "[", "data", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMI\>\"", ",", " ", 
      RowBox[{"{", "}"}], ",", " ", 
      RowBox[{"{", "int_", "}"}]}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"OMInteger", "[", 
    RowBox[{"ToExpression", "[", "int", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMOBJ\>\"", ",", " ", 
      RowBox[{"{", "}"}], ",", " ", 
      RowBox[{"{", "om_", "}"}]}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"OMObject", "[", 
    RowBox[{"OpenMath", "[", "om", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMR\>\"", ",", " ", "n_", ",", " ", "x_"}], "]"}], "]"}], 
   " ", ":=", " ", 
   RowBox[{"OMReference", "[", 
    RowBox[{"\"\<href\>\"", "/.", "n"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMSTR\>\"", ",", " ", 
      RowBox[{"{", "}"}], ",", " ", 
      RowBox[{"{", "str_", "}"}]}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"OMString", "[", 
    RowBox[{"ToString", "[", "str", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMS\>\"", ",", " ", "n_", ",", " ", "x_"}], "]"}], "]"}], 
   " ", ":=", " ", 
   RowBox[{"OMSymbol", "[", 
    RowBox[{"Sequence", "@@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<cd\>\"", ",", " ", "\"\<name\>\""}], "}"}], "/.", "n"}], 
      ")"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OpenMath", "[", 
    RowBox[{"XMLElement", "[", 
     RowBox[{"\"\<OMV\>\"", ",", " ", "n_", ",", " ", "x_"}], "]"}], "]"}], 
   " ", ":=", " ", 
   RowBox[{"OMVariable", "[", 
    RowBox[{"\"\<name\>\"", "/.", "n"}], "]"}]}], ";"}]}], "Code",
 CellChangeTimes->{3.512388199733478*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Additional Code for User Interface and for Keeping ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Expression Unevaluated"
}], "Subsection",
 CellChangeTimes->{{3.512388500679613*^9, 3.512388538547774*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"MathString2OMObject", "[", "s_String", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "expr", "}"}], ",", "\n", 
    RowBox[{
     RowBox[{"expr", " ", "=", " ", 
      RowBox[{"ToExpression", "[", 
       RowBox[{"s", ",", " ", "InputForm"}], "]"}]}], ";", "\n", 
     RowBox[{"Apply", "[", 
      RowBox[{"Math2OM", ",", " ", "expr"}], "]"}]}]}], "\n", "]"}]}]], "Code",\

 CellChangeTimes->{3.512287626823855*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Mathematica2OMObject", "[", "expr_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"s", ",", " ", "e"}], "}"}], ",", "\n", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"Unevaluated", "[", "expr", "]"}], ",", " ", "_Symbol"}], 
       "]"}], ",", "\n", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{"expr", ",", " ", "_Hold"}], "]"}], ",", "\n", 
        RowBox[{
         RowBox[{"s", " ", "=", " ", 
          RowBox[{"ToString", "[", 
           RowBox[{
            RowBox[{"ReleaseHold", "[", 
             RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}], ",", " ", 
            "InputForm"}], "]"}]}], ";", 
         RowBox[{"MathString2OMObject", "[", "s", "]"}]}], ",", "\n", 
        RowBox[{"Math2OM", "[", 
         RowBox[{"Evaluate", "[", "expr", "]"}], "]"}]}], "\n", "]"}], ",", 
      "\n", 
      RowBox[{
       RowBox[{"s", " ", "=", " ", 
        RowBox[{"ToString", "[", 
         RowBox[{
          RowBox[{"Hold", "[", "expr", "]"}], ",", " ", "InputForm"}], 
         "]"}]}], ";", 
       RowBox[{"MathString2OMObject", "[", "s", "]"}]}]}], "\n", "]"}]}], 
   "\n", "]"}]}]], "Code",
 CellChangeTimes->{3.512389577376354*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"XML2OMObject", "[", "s_String", "]"}], " ", ":=", " ", 
   RowBox[{"OpenMath", "[", 
    RowBox[{"ImportString", "[", 
     RowBox[{"s", ",", "\"\<XML\>\""}], "]"}], "]"}]}], ";"}]], "Code"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Mathematica2XML", "[", "M_", "]"}], " ", ":=", " ", 
   RowBox[{"OMObject2XML", "[", 
    RowBox[{"Mathematica2OMObject", "[", 
     RowBox[{"Unevaluated", "[", "M", "]"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"XML2Mathematica", "[", "X_", "]"}], " ", ":=", " ", 
   RowBox[{"OMObject2Mathematica", "[", 
    RowBox[{"XML2OMObject", "[", "X", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"Math2OM", ",", " ", "HoldAll"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"Mathematica2OMObject", ",", " ", "HoldFirst"}], "]"}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"Mathematica2XML", ",", " ", "HoldFirst"}], "]"}], ";"}]}], "Code",\

 CellChangeTimes->{{3.512456176725267*^9, 3.512456178075808*^9}, 
   3.51245632721019*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{
   "OMObject2XML", ",", " ", "XML2OMObject", ",", " ", "OMObject2Mathematica",
     ",", " ", "Mathematica2OMObject", ",", " ", "Mathematica2XML", ",", " ", 
    "XML2Mathematica"}], "]"}], ";"}]], "Code",
 CellChangeTimes->{{3.512456176725267*^9, 3.512456178075808*^9}, 
   3.51245632721019*^9}],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Code"],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Code",
 CellChangeTimes->{{3.51231127468444*^9, 3.51231127610013*^9}}]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1400, 975},
WindowMargins->{{1, Automatic}, {24, Automatic}},
FrontEndVersion->"7.0 for Linux x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 99, 1, 85, "Title"],
Cell[669, 25, 1865, 41, 159, "Code"],
Cell[2537, 68, 80, 1, 48, "Code"],
Cell[2620, 71, 1574, 34, 159, "Code"],
Cell[CellGroupData[{
Cell[4219, 109, 103, 1, 39, "Subsection"],
Cell[4325, 112, 1481, 31, 115, "Code"],
Cell[5809, 145, 73, 1, 48, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5919, 151, 103, 1, 39, "Subsection"],
Cell[CellGroupData[{
Cell[6047, 156, 173, 3, 29, "Subsubsection"],
Cell[6223, 161, 1654, 39, 137, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7914, 205, 119, 1, 29, "Subsubsection"],
Cell[8036, 208, 563, 10, 48, "Code"],
Cell[8602, 220, 905, 23, 291, "Code"],
Cell[9510, 245, 379, 12, 48, "Code"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9938, 263, 123, 1, 39, "Subsection"],
Cell[10064, 266, 4348, 123, 225, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14449, 394, 200, 6, 39, "Subsection"],
Cell[14652, 402, 1488, 39, 181, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16177, 446, 199, 6, 39, "Subsection"],
Cell[16379, 454, 1386, 38, 225, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17802, 497, 123, 1, 39, "Subsection"],
Cell[17928, 500, 4358, 123, 269, "Code"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22323, 628, 231, 6, 39, "Subsection"],
Cell[22557, 636, 483, 13, 115, "Code"],
Cell[23043, 651, 1334, 36, 225, "Code"],
Cell[24380, 689, 237, 6, 48, "Code"],
Cell[24620, 697, 896, 24, 137, "Code"],
Cell[25519, 723, 359, 8, 48, "Code"],
Cell[25881, 733, 50, 1, 48, "Code"],
Cell[25934, 736, 121, 2, 48, "Code"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
