(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     49953,       1137]
NotebookOptionsPosition[     48026,       1074]
NotebookOutlinePosition[     48396,       1090]
CellTagsIndexPosition[     48353,       1087]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"SCSCP", " ", "Package", " ", 
    RowBox[{"(", "c", ")"}], " ", "2011", " ", "Karoly", " ", "Bosa", " ", 
    "and", " ", "Peter", " ", 
    RowBox[{"Horn", ".", " ", "Licensed"}], " ", "under", " ", "the", " ", 
    "Apache", " ", "License"}], ",", 
   RowBox[{
    RowBox[{"Version", " ", "2.0", " ", 
     RowBox[{"(", 
      RowBox[{"the", " ", "\"\<License\>\""}], ")"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
     "you", " ", "may", " ", "not", " ", "use", " ", "this", " ", "file", " ",
       "except", " ", "in", " ", "compliance", " ", "with", " ", "the", " ", 
      RowBox[{"License", ".", "You"}], " ", "may", " ", "obtain", " ", "a", 
      " ", "copy", " ", "of", " ", "the", " ", "License", " ", "at", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"http", ":"}]}], "//", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"www", ".", "apache", ".", "org"}], "/", "licenses"}], "/", 
       "LICENSE"}], "-", 
      RowBox[{
      "2.0", " ", "Unless", " ", "required", " ", "by", " ", "applicable", 
       " ", "law", " ", "or", " ", "agreed", " ", "to", " ", "in", " ", 
       "writing"}]}]}]}], ",", 
   RowBox[{
   "software", " ", "distributed", " ", "under", " ", "the", " ", "License", 
    " ", "is", " ", "distributed", " ", "on", " ", "an", " ", "\"\<AS IS\>\"",
     " ", "BASIS"}], ",", 
   RowBox[{
   "WITHOUT", " ", "WARRANTIES", " ", "OR", " ", "CONDITIONS", " ", "OF", " ",
     "ANY", " ", "KIND"}], ",", 
   RowBox[{"either", " ", "express", " ", "or", " ", 
    RowBox[{"implied", ".", "See"}], " ", "the", " ", "License", " ", "for", 
    " ", "the", " ", "specific", " ", "language", " ", "governing", " ", 
    "permissions", " ", "and", " ", "limitations", " ", "under", " ", "the", 
    " ", 
    RowBox[{"License", "."}]}]}], "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.511756219811628*^9, 3.511756254581381*^9}}],

Cell[BoxData[
 RowBox[{"BeginPackage", "[", "\"\<SCSCP`\>\"", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.510835311059948*^9, 3.510835328974218*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Java", "::", "usage"}], " ", "=", " ", 
   "\"\<OMObject2Java[O] converts an (internal) OpenMath object tree \
representation to Symcomp java OpenMath representation.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPInit", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPInit[path] sets the location of SCSCP4Mathematica.jar in the \
classpath. The default location is '.' .\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPConnectionInit", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPConnectionInit[server, port] initializes a connection (opens a \
socket to the given SCSCP server).\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPConnectionClose", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPConnectionClose[connection] closes the given connection (and the \
socket).\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPComputeBlocking", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPComputeBlocking[expr, service, connection] converts a \
Mathematica expression into OpenMath format and sends it to an SCSCP server. \
It blocks until the result is available, then returns with it. Service \
denotes the name of the service which will be use on the SCSCP server.\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPCompute", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPCompute[expr, service, connection] converts a Mathematica \
expression into OpenMath format and sends it to an SCSCP server, then it \
returns immediately. Service denotes the name of the service which will be \
use on the SCSCP server.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPWait", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPWait[token] blocks until the result of the computation \
identified by token is available and returns with it.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SCSCPProbe", "::", "usage"}], " ", "=", " ", 
  "\"\<SCSCPProbe[token] returns with the state of the computation identified \
by the token\>\""}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPComputeXMLBlocking", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPComputeXMLBlocking[expr, connection] sends an xml-based OpenMath \
expression to an SCSCP server. It blocks until the result is available, then \
returns with it.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPComputeXML", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPComputeXML[expr, connection]  sends an xml-based OpenMath \
expression to an SCSCP server, then it returns immediately.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"StartSCSCPServer", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPServer[port, logLevel] starts a server which listening for \
client connections on the given port. Events are logged with given \
logLevel(from 1 to 5).\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPRequestEvaluation", "::", "usage"}], " ", "=", " ", 
   "\"\<SCSCPRequestEvaluation is called by Java server.\>\""}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.510835793337276*^9, 3.510835912998439*^9}, {
   3.510836046288866*^9, 3.510836076133855*^9}, {3.510836110794042*^9, 
   3.510836197515523*^9}, {3.510921728582122*^9, 3.510921748778484*^9}, {
   3.510921827361905*^9, 3.510921891351498*^9}, {3.510938090303126*^9, 
   3.510938093611608*^9}, {3.510938362450495*^9, 3.510938372761369*^9}, {
   3.510938412683203*^9, 3.510938442683901*^9}, {3.511010592055936*^9, 
   3.511010612371704*^9}, {3.511010665851902*^9, 3.511010690514237*^9}, {
   3.511011964884143*^9, 3.511011965417664*^9}, {3.511507160584931*^9, 
   3.511507181270277*^9}, {3.511507465265075*^9, 3.511507478078878*^9}, {
   3.511585498940482*^9, 3.51158553138697*^9}, {3.511586996654051*^9, 
   3.511586999963183*^9}, 3.511587517475632*^9, 3.511587995599834*^9, {
   3.511698489577124*^9, 3.511698582374493*^9}, {3.511699702088061*^9, 
   3.511699735365688*^9}, {3.511723949534407*^9, 3.511723973269993*^9}, {
   3.511724294830499*^9, 3.511724305738464*^9}, {3.511756319434783*^9, 
   3.51175667402385*^9}, {3.511756709784356*^9, 3.511756746899328*^9}, {
   3.511756844674887*^9, 3.511757041561448*^9}, {3.512108936826642*^9, 
   3.512108941100042*^9}, {3.512452113976363*^9, 3.512452166046127*^9}, {
   3.512453749721081*^9, 3.512453900675946*^9}, {3.512453935776277*^9, 
   3.512453949597765*^9}, {3.51245620136124*^9, 3.512456202639367*^9}, {
   3.51245656152455*^9, 3.512456562508997*^9}, {3.533032787450565*^9, 
   3.533032887193889*^9}, {3.533032917272541*^9, 3.533032917953954*^9}, {
   3.533033969022848*^9, 3.533033970045669*^9}, {3.533035461834455*^9, 
   3.533035485853671*^9}},
 Background->GrayLevel[0.85]],

Cell[BoxData[
 RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51083534620453*^9, 3.510835360516076*^9}, {
  3.511260646390836*^9, 3.511260650447009*^9}}],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<JLink`\>\"", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51083537083834*^9, 3.510835391073847*^9}}],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<OpenMath`\>\"", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.510835399731359*^9, 3.510835420563103*^9}}],

Cell[BoxData[{
 RowBox[{"SCSCP`Initialized", " ", "=", " ", "False"}], "\[IndentingNewLine]", 
 RowBox[{"ListOfConnections", " ", "=", " ", 
  RowBox[{"{", "}"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.510934649527704*^9, 3.510934654286867*^9}, {
   3.51093469995769*^9, 3.510934700589249*^9}, {3.510934918015954*^9, 
   3.510934957883708*^9}, 3.510938466500101*^9, 3.510938545878338*^9, {
   3.510938602848474*^9, 3.510938605787157*^9}, {3.51171860363388*^9, 
   3.511718604421977*^9}, {3.511772890685056*^9, 3.511772967065593*^9}, {
   3.512102192863242*^9, 3.512102214977743*^9}, {3.512103312136647*^9, 
   3.512103313821538*^9}, {3.512452247065766*^9, 3.512452250637142*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCSCPInit", "[", "]"}], " ", ":=", " ", 
  RowBox[{"SCSCPInit", "[", "\"\<.\>\"", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.512451957503287*^9, 3.512451976111188*^9}, {
  3.512452023447906*^9, 3.512452048084616*^9}, {3.512452237501845*^9, 
  3.512452244904653*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCSCPInit", "[", "path_String", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "cp", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"cp", " ", "=", " ", 
      RowBox[{"path", "<>", "\"\</SCSCP4Mathematica.jar\>\""}]}], ";", 
     "\[IndentingNewLine]", " ", 
     RowBox[{"ReinstallJava", "[", 
      RowBox[{"ClassPath", "\[Rule]", " ", "cp"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{
     "LoadJavaClass", "[", "\"\<org.symcomp.mathematica.MathServer\>\"", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{
     "LoadJavaClass", "[", "\"\<org.symcomp.scscp.ComputationState\>\"", 
      "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SCSCP`Initialized", " ", "=", " ", "True"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", 
      RowBox[{"\"\<Classpath: \>\"", "<>", "cp"}], "]"}], ";"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.510837052462916*^9, 3.510837059431843*^9}, {
   3.5108451775919*^9, 3.510845177753757*^9}, {3.510845220694122*^9, 
   3.510845254105676*^9}, {3.510921948566723*^9, 3.510921973310102*^9}, {
   3.510922208362897*^9, 3.51092223067282*^9}, {3.510922332006373*^9, 
   3.510922420275006*^9}, {3.510922474650496*^9, 3.510922478093981*^9}, {
   3.510922602183282*^9, 3.510922625913688*^9}, {3.510935088593617*^9, 
   3.51093509874418*^9}, {3.510938610972839*^9, 3.51093861344776*^9}, {
   3.511266511285904*^9, 3.511266564343017*^9}, {3.51175417631776*^9, 
   3.51175420311691*^9}, {3.511754297421251*^9, 3.511754298612277*^9}, {
   3.511754363306077*^9, 3.511754364233436*^9}, 3.512111070683232*^9, {
   3.512451845095183*^9, 3.512451867983945*^9}, {3.512452061431892*^9, 
   3.512452089797062*^9}, {3.512452295403437*^9, 3.512452316585026*^9}}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"SCSCPConnectionInit", "[", 
    RowBox[{"server_", ",", " ", "port_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "jclient", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"SCSCP`Initialized", " ", "\[Equal]", " ", "True"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"jclient", " ", "=", " ", 
         RowBox[{"JavaNew", "[", 
          RowBox[{
          "\"\<org.symcomp.scscp.SCSCPClient\>\"", ",", " ", "server", ",", 
           " ", "port"}], " ", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{"ListOfConnections", ",", " ", 
          RowBox[{"{", 
           RowBox[{"jclient", ",", " ", "server", ",", " ", "port"}], "}"}]}],
          "]"}], ";", "\[IndentingNewLine]", "jclient"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
       "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", 
        "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.511723988833844*^9, 3.511724036553284*^9}, {
  3.511724117598261*^9, 3.511724144336484*^9}, {3.511724442011831*^9, 
  3.511724442117851*^9}, {3.511724954332719*^9, 3.511724955806945*^9}, {
  3.511725113456009*^9, 3.511725115089536*^9}, {3.511772990514401*^9, 
  3.511773002458459*^9}, {3.512102234762997*^9, 3.512102360358819*^9}, {
  3.512102450903491*^9, 3.512102451680146*^9}, {3.512104362598486*^9, 
  3.512104372641897*^9}, {3.512104787259741*^9, 3.512104794663809*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCSCPConnectionClose", "[", "jclient_", "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "conn", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SCSCP`Initialized", " ", "\[Equal]", " ", "True"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "ListOfConnections", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"conn", " ", "=", " ", 
           RowBox[{"ListOfConnections", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"conn", "[", 
              RowBox[{"[", "1", "]"}], "]"}], " ", "\[Equal]", " ", 
             "jclient"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<Connection was closed with the server \>\"", "<>", 
               RowBox[{"conn", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<:\>\"", "<>", 
               RowBox[{"conn", "[", 
                RowBox[{"[", "3", "]"}], "]"}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Break", "[", "]"}]}], ",", "\[IndentingNewLine]", 
            "Null"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"jclient", "@", 
        RowBox[{"quit", "[", "]"}]}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
      "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", "]"}]}],
      "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51172431491161*^9, 3.511724333297102*^9}, {
   3.511724366218084*^9, 3.511724450735371*^9}, {3.511724844402941*^9, 
   3.51172484817497*^9}, {3.511809096796419*^9, 3.511809098677445*^9}, {
   3.51210112544188*^9, 3.512101133543823*^9}, {3.512101529273714*^9, 
   3.512101640045218*^9}, {3.512101797541012*^9, 3.512101817836403*^9}, 
   3.512101869229409*^9, {3.512102483451349*^9, 3.512102494729797*^9}, {
   3.512102656109085*^9, 3.512102657478337*^9}, {3.512102690536414*^9, 
   3.512102735972813*^9}, {3.512102778805698*^9, 3.512102834608769*^9}, {
   3.512102878481043*^9, 3.512103000350764*^9}, {3.512103151541452*^9, 
   3.512103152445517*^9}, {3.512104559583787*^9, 3.512104564837076*^9}, {
   3.512104683297531*^9, 3.512104685144883*^9}, {3.512104767488876*^9, 
   3.512104772945745*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"AddOMHeader", "[", 
   RowBox[{"OM_", ",", " ", "service_String"}], "]"}], " ", ":=", " ", 
  RowBox[{"OMApply", "[", 
   RowBox[{
    RowBox[{"OMSymbol", "[", 
     RowBox[{"\"\<scscp_transient_1\>\"", ",", " ", "service"}], "]"}], ",", 
    " ", 
    RowBox[{"{", "OM", "}"}]}], "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.511508284115582*^9, 3.511508368280786*^9}, {
  3.511508443397479*^9, 3.511508527733632*^9}, {3.511508562971143*^9, 
  3.511508576025383*^9}, {3.511725283706302*^9, 3.51172531890938*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "Jv", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMApply", "[", 
     RowBox[{"head_", ",", "params_"}], "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMApply\>\"", ",", 
     RowBox[{"Jv", "[", "head", "]"}], ",", 
     RowBox[{"ReturnAsJavaObject", "[", 
      RowBox[{
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ReturnAsJavaObject", "[", 
           RowBox[{"#1", "@", 
            RowBox[{"add", "[", 
             RowBox[{"Jv", "[", "#2", "]"}], "]"}]}], "]"}], "&"}], ",", 
         RowBox[{"JavaNew", "[", "\"\<org.symcomp.openmath.OMList\>\"", "]"}],
          ",", "params"}], "]"}], "@", 
       RowBox[{"array", "[", "]"}]}], " ", "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMBinary", "[", "payload_", "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMBinary\>\"", ",", "payload"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMBind", "[", 
     RowBox[{"symbol_", ",", "vars_", ",", "expr_"}], "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMBind\>\"", ",", 
     RowBox[{"Jv", "[", "symbol", "]"}], ",", 
     RowBox[{"Jv", "[", "vars", "]"}], ",", 
     RowBox[{"Jv", "[", "expr", "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMError", "[", 
     RowBox[{"head_", ",", "params_"}], "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMErrdist`or\>\"", ",", 
     RowBox[{"Jv", "[", "head", "]"}], ",", 
     RowBox[{"ReturnAsJavaObject", "[", 
      RowBox[{
       RowBox[{"Fold", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ReturnAsJavaObject", "[", 
           RowBox[{"#1", "@", 
            RowBox[{"add", "[", 
             RowBox[{"Jv", "[", "#2", "]"}], "]"}]}], "]"}], "&"}], ",", 
         RowBox[{"JavaNew", "[", "\"\<org.symcomp.openmath.OMList\>\"", "]"}],
          ",", "params"}], "]"}], "@", 
       RowBox[{"array", "[", "]"}]}], " ", "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMFloat", "[", "float_", "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMFloat\>\"", ",", "float"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMForeign", "[", "payload_", "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMForeign\>\"", ",", "payload"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMInteger", "[", "int_", "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMInteger\>\"", ",", "int"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMObject", "[", "obj_", "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMObject\>\"", ",", 
     RowBox[{"Jv", "[", "obj", "]"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMReference", "[", "href_", "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMReference\>\"", ",", "href"}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMString", "[", "str_", "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMString\>\"", ",", "str"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Jv", "[", 
    RowBox[{"OMSymbol", "[", 
     RowBox[{"cd_", ",", "name_"}], "]"}], "]"}], ":=", 
   RowBox[{"JavaNew", "[", 
    RowBox[{"\"\<org.symcomp.openmath.OMSymbol\>\"", ",", "cd", ",", "name"}],
     "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Jv", "[", 
   RowBox[{"OMVariable", "[", "name_", "]"}], "]"}], ":=", 
  RowBox[{"JavaNew", "[", 
   RowBox[{"\"\<org.symcomp.openmath.OMVariable\>\"", ",", "name"}], 
   "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.510835664851855*^9, 3.510835688842464*^9}, 
   3.510934710920611*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OMObject2Java", "[", "OM_", "]"}], " ", ":=", " ", 
   RowBox[{"Jv", "[", "OM", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.510836238870517*^9, 3.510836322269519*^9}, {
   3.511093850707953*^9, 3.511093860813893*^9}, 3.511094426598901*^9, {
   3.511094949916497*^9, 3.511094952497333*^9}, {3.511095884827713*^9, 
   3.511095892196906*^9}, {3.511095995877907*^9, 3.511095998861663*^9}, {
   3.511096073751391*^9, 3.511096078828754*^9}, {3.511239377055445*^9, 
   3.511239379908274*^9}, {3.51124863585415*^9, 3.511248642587182*^9}, {
   3.511508158283991*^9, 3.511508170630214*^9}, 3.51158751922436*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCSCPComputeBlocking", "[", 
   RowBox[{"expr_", ",", " ", "service_String", ",", "jclient_"}], "]"}], " ",
   ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "jin", ",", " ", "jout", ",", " ", "OMTree", ",", "OMWithHeader", ",", 
      " ", "conn"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SCSCP`Initialized", " ", "\[Equal]", " ", "True"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "ListOfConnections", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"conn", " ", "=", " ", 
           RowBox[{"ListOfConnections", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"conn", "[", 
              RowBox[{"[", "1", "]"}], "]"}], " ", "\[Equal]", " ", 
             "jclient"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<Expression \\\"\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{
                 RowBox[{"Unevaluated", "[", "expr", "]"}], ",", " ", 
                 "InputForm"}], "]"}], "<>", 
               "\"\<\\\" is sent to the SCSCP server \>\"", "<>", 
               RowBox[{"conn", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<:\>\"", "<>", 
               RowBox[{"conn", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<.\>\""}], " ", 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Break", "[", "]"}]}], ",", "\[IndentingNewLine]", 
            "Null"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"OMTree", " ", "=", " ", 
        RowBox[{"Mathematica2OMObject", "[", 
         RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"service", "\[Equal]", "\"\<\>\""}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"OMWithHeader", " ", "=", " ", "OMTree"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"OMWithHeader", " ", "=", " ", 
          RowBox[{"AddOMHeader", "[", 
           RowBox[{"OMTree", ",", " ", "service"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
       "Print", "[", "\"\<------------------------------------------\>\"", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"OMObject2XML", "[", "OMWithHeader", "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
       "Print", "[", "\"\<------------------------------------------\>\"", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"jin", " ", "=", " ", 
        RowBox[{"OMObject2Java", "[", "OMWithHeader", "]"}]}], ";", " ", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"org`sympcomp`openmath`OpenMathBase`parseXml", 
          RowBox[{"(", 
           RowBox[{"Mathematica2XML", 
            RowBox[{"(", "expr", ")"}]}], ")"}]}], "<", 
         RowBox[{
          RowBox[{"--", "NOT"}], " ", "WORKING"}]}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "[", "\"\<Waiting for the answer...\>\"", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"jout", " ", "=", " ", 
        RowBox[{"jclient", "@", 
         RowBox[{"computeBlocking", "[", "jin", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"XML2Mathematica", "[", 
        RowBox[{"jout", "@", 
         RowBox[{"toXml", "[", "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
      "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", "]"}]}],
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.510836340220721*^9, 3.510836341490474*^9}, {
   3.510836401181866*^9, 3.510836431485753*^9}, {3.51083652880644*^9, 
   3.510836639511578*^9}, {3.510836681001786*^9, 3.510836797181467*^9}, {
   3.510836830553676*^9, 3.510836844395259*^9}, {3.510845066963132*^9, 
   3.510845076048465*^9}, 3.510845113672656*^9, {3.510922768229945*^9, 
   3.51092277373049*^9}, {3.510923278674577*^9, 3.510923279146803*^9}, {
   3.510923361160501*^9, 3.510923363254063*^9}, 3.510935017988431*^9, {
   3.510935048552268*^9, 3.510935053902713*^9}, {3.510935113812386*^9, 
   3.510935131821572*^9}, {3.510935259031253*^9, 3.510935337769573*^9}, {
   3.510935372897724*^9, 3.510935432393362*^9}, {3.510936501726765*^9, 
   3.510936536103932*^9}, {3.510936923693105*^9, 3.510936927764753*^9}, {
   3.510937015278146*^9, 3.510937018840116*^9}, {3.510937246563251*^9, 
   3.510937253898168*^9}, {3.51093737929934*^9, 3.510937388818308*^9}, {
   3.510937599438848*^9, 3.510937605934303*^9}, {3.510937877422434*^9, 
   3.510937884136965*^9}, {3.510938017678138*^9, 3.510938060422086*^9}, {
   3.510938103246198*^9, 3.510938130080131*^9}, {3.510938322280757*^9, 
   3.510938335719921*^9}, {3.510938620941289*^9, 3.51093862258085*^9}, {
   3.511017930614749*^9, 3.511017974969271*^9}, {3.5110180179584618`*^9, 
   3.511018031395999*^9}, {3.511093820120913*^9, 3.511093836793967*^9}, 
   3.511094310645465*^9, {3.511094562333544*^9, 3.511094565795632*^9}, {
   3.511094731475171*^9, 3.511094779209326*^9}, {3.511094811105656*^9, 
   3.511094928126419*^9}, {3.511095053703144*^9, 3.511095059330413*^9}, 
   3.511095160175946*^9, {3.511507871708162*^9, 3.511507903868929*^9}, {
   3.511507949560349*^9, 3.511507967123591*^9}, {3.511507997972483*^9, 
   3.511508035139218*^9}, {3.511508122137339*^9, 3.51150819101916*^9}, {
   3.511508691163384*^9, 3.511508709134322*^9}, {3.51158209287196*^9, 
   3.511582099815643*^9}, {3.51158698035671*^9, 3.511586983208646*^9}, 
   3.511587521190892*^9, {3.511590563420493*^9, 3.5115905732769*^9}, {
   3.511590734972946*^9, 3.51159074505623*^9}, {3.511590799830611*^9, 
   3.511590817781576*^9}, {3.511724215586721*^9, 3.511724242779442*^9}, {
   3.511724485655133*^9, 3.511724488584721*^9}, {3.511724860041642*^9, 
   3.511724865175623*^9}, {3.511725128288453*^9, 3.511725133880865*^9}, {
   3.511725275836584*^9, 3.51172527742522*^9}, {3.511772450676911*^9, 
   3.511772458608783*^9}, {3.511772606649791*^9, 3.511772607434058*^9}, {
   3.511773008613393*^9, 3.511773011791074*^9}, {3.511856104878178*^9, 
   3.511856128614358*^9}, {3.511858859021355*^9, 3.511858875627315*^9}, {
   3.512103458761406*^9, 3.512103475352893*^9}, {3.512103507420771*^9, 
   3.512103515455208*^9}, {3.512103568247299*^9, 3.512103568671567*^9}, 
   3.512103622789537*^9, {3.512104752650785*^9, 3.512104753238876*^9}, {
   3.512110852877345*^9, 3.512110896041428*^9}, {3.512110940181369*^9, 
   3.512110949806637*^9}, {3.512117577453486*^9, 3.51211758098878*^9}, {
   3.512117776038221*^9, 3.512117783761688*^9}, {3.512134704467257*^9, 
   3.512134710239058*^9}, {3.51213493485313*^9, 3.512134940177248*^9}, {
   3.512135638984987*^9, 3.512135646716033*^9}, {3.512135768221832*^9, 
   3.51213577426343*^9}, {3.512135846054471*^9, 3.512135846833904*^9}, {
   3.512135971856579*^9, 3.512135977155301*^9}, 3.533031097671059*^9, {
   3.533031133830869*^9, 3.533031200818838*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCSCPCompute", "[", 
   RowBox[{"expr_", ",", " ", "service_String", ",", "jclient_"}], "]"}], " ",
   ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "jin", ",", " ", "OMTree", ",", "OMWithHeader", ",", " ", "conn"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SCSCP`Initialized", " ", "\[Equal]", " ", "True"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "ListOfConnections", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"conn", " ", "=", " ", 
           RowBox[{"ListOfConnections", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"conn", "[", 
              RowBox[{"[", "1", "]"}], "]"}], " ", "\[Equal]", " ", 
             "jclient"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<Expression \\\"\>\"", "<>", 
               RowBox[{"ToString", "[", 
                RowBox[{
                 RowBox[{"Unevaluated", "[", "expr", "]"}], ",", " ", 
                 "InputForm"}], "]"}], "<>", 
               "\"\<\\\" is sent to the SCSCP server \>\"", "<>", 
               RowBox[{"conn", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<:\>\"", "<>", 
               RowBox[{"conn", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<.\>\""}], " ", 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Break", "[", "]"}]}], ",", "\[IndentingNewLine]", 
            "Null"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"OMTree", " ", "=", " ", 
        RowBox[{"Mathematica2OMObject", "[", 
         RowBox[{"Unevaluated", "[", "expr", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"service", "\[Equal]", "\"\<\>\""}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"OMWithHeader", " ", "=", " ", "OMTree"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"OMWithHeader", " ", "=", " ", 
          RowBox[{"AddOMHeader", "[", 
           RowBox[{"OMTree", ",", " ", "service"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
       "Print", "[", "\"\<------------------------------------------\>\"", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", 
        RowBox[{"OMObject2XML", "[", "OMWithHeader", "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
       "Print", "[", "\"\<------------------------------------------\>\"", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"jin", " ", "=", " ", 
        RowBox[{"OMObject2Java", "[", "OMWithHeader", "]"}]}], ";", " ", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"org`sympcomp`openmath`OpenMathBase`parseXml", 
          RowBox[{"(", 
           RowBox[{"Mathematica2XML", 
            RowBox[{"(", "expr", ")"}]}], ")"}]}], "<", 
         RowBox[{
          RowBox[{"--", "NOT"}], " ", "WORKING"}]}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"jclient", "@", 
        RowBox[{"compute", "[", "jin", "]"}]}]}], ",", "\[IndentingNewLine]", 
      
      RowBox[{
      "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", "]"}]}],
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.511698615061224*^9, 3.511698616363777*^9}, {
   3.511698722568221*^9, 3.511698756071334*^9}, {3.511698822083354*^9, 
   3.511698838027979*^9}, {3.511699038912652*^9, 3.511699041642861*^9}, 
   3.511724139630459*^9, {3.511724171636557*^9, 3.511724196137673*^9}, {
   3.511724871304937*^9, 3.511724874538976*^9}, {3.511725221128913*^9, 
   3.511725247518908*^9}, {3.511773024901276*^9, 3.511773033020129*^9}, {
   3.511773452872012*^9, 3.511773455044088*^9}, {3.512103573498548*^9, 
   3.512103616119998*^9}, {3.512104716885238*^9, 3.512104742492619*^9}, 
   3.512110968258715*^9, {3.512117589533171*^9, 3.512117592908188*^9}, {
   3.512117753789492*^9, 3.512117761747897*^9}, 3.53303123563729*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCSCPProbe", "[", 
   RowBox[{"token_String", ",", " ", "jclient_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "state", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SCSCP`Initialized", " ", "=", " ", "True"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"state", " ", "=", " ", 
        RowBox[{"jclient", "@", 
         RowBox[{"getResult", "[", "token", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"state", " ", "=", " ", 
        RowBox[{"jclient", "@", 
         RowBox[{"getComputationState", "[", "token", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Which", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "state", "\[Equal]", " ", 
          "org`symcomp`scscp`ComputationState`WAITING"}], ",", " ", 
         "\"\<WAITING\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{
         "state", "\[Equal]", " ", 
          "org`symcomp`scscp`ComputationState`COMPUTING"}], ",", " ", 
         "\"\<COMPUTING\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{
         "state", "\[Equal]", " ", 
          "org`symcomp`scscp`ComputationState`READY"}], ",", " ", 
         "\"\<READY\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{
         "state", "\[Equal]", " ", 
          "org`symcomp`scscp`ComputationState`ERRONEOUS"}], ",", " ", 
         "\"\<ERRONEOUS\>\""}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
      "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", "]"}]}],
      "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.511699536310265*^9, 3.511699627046886*^9}, {
   3.511699674985184*^9, 3.511699675994268*^9}, {3.511724525888389*^9, 
   3.511724535355226*^9}, {3.511724881691285*^9, 3.511724884702651*^9}, {
   3.511724919104046*^9, 3.511724938288871*^9}, 3.511724990678078*^9, {
   3.511753890285369*^9, 3.511753895074112*^9}, {3.511753932807063*^9, 
   3.511753951424962*^9}, 3.511753983507584*^9, {3.511754030015269*^9, 
   3.511754032217865*^9}, {3.511754371884194*^9, 3.511754389160535*^9}, {
   3.511754485643398*^9, 3.511754716028078*^9}, {3.511754806298858*^9, 
   3.511754807237709*^9}, {3.511773457953613*^9, 3.511773459629201*^9}, {
   3.512103630523432*^9, 3.512103632771859*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCSCPWait", "[", 
   RowBox[{"token_String", ",", " ", "jclient_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "jout", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SCSCP`Initialized", " ", "=", " ", "True"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"!", 
          RowBox[{"jclient", "@", 
           RowBox[{"resultAvailable", "[", "token", "]"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Pause", "[", "2", "]"}]}], "\[IndentingNewLine]", "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"jout", "=", " ", 
        RowBox[{"jclient", "@", 
         RowBox[{"getResult", "[", "token", "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"XML2Mathematica", "[", 
        RowBox[{"jout", "@", 
         RowBox[{"toXml", "[", "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{
      "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", "]"}]}],
      "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51169904636823*^9, 3.511699077875972*^9}, {
   3.511699151592061*^9, 3.511699203392356*^9}, {3.511699371219099*^9, 
   3.511699476423111*^9}, {3.511699686216521*^9, 3.511699692736775*^9}, {
   3.511699766135809*^9, 3.511699774164952*^9}, {3.511724908272951*^9, 
   3.511724914387825*^9}, {3.511725011870766*^9, 3.511725026716068*^9}, {
   3.51172534234323*^9, 3.511725343218663*^9}, {3.511754036017518*^9, 
   3.511754040041586*^9}, {3.511754861945035*^9, 3.511754883241079*^9}, {
   3.511755264871945*^9, 3.511755273069743*^9}, {3.51175530837729*^9, 
   3.511755318892448*^9}, {3.511755355844586*^9, 3.511755374870282*^9}, 
   3.511755498674281*^9, {3.511755684217729*^9, 3.511755711181315*^9}, 
   3.511756304404484*^9, {3.511773467332493*^9, 3.51177346889666*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"SCSCPComputeBlocking", ",", " ", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"SCSCPCompute", ",", " ", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"AddOMHeader", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"OMObject2Java", ",", "HoldFirst"}], "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.511094587010243*^9, 3.511094623997768*^9}, {
   3.51109517477656*^9, 3.511095213089011*^9}, {3.51150809077581*^9, 
   3.511508109032992*^9}, 3.511587523491004*^9, 3.511587999603499*^9, {
   3.511698902929237*^9, 3.511698908279907*^9}, {3.512132754023324*^9, 
   3.512132761374884*^9}, {3.512133066014179*^9, 3.512133068266288*^9}, {
   3.512133612710161*^9, 3.512133639507825*^9}, {3.512136190716694*^9, 
   3.51213619474626*^9}, {3.512136480237561*^9, 3.51213648253941*^9}, {
   3.512200672528509*^9, 3.512200680954952*^9}, {3.512201015225078*^9, 
   3.512201017452662*^9}, {3.512201230683758*^9, 3.512201233723857*^9}, {
   3.512284662162548*^9, 3.512284664795754*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"StartSCSCPServer", "[", 
   RowBox[{"port_", ",", " ", "logLevel_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SCSCP`Initialized", " ", "\[Equal]", " ", "True"}], " ", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"logLevel", ">=", "0"}], " ", "||", " ", 
         RowBox[{"logLevel", "<=", "5"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"org`symcomp`mathematica`MathServer`startMathServer", "[", 
         RowBox[{"port", ",", " ", "logLevel"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<Incorrect logging level!\>\"", "]"}]}], 
       "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{
      "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", "]"}]}],
      "]"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQA2IQHdZQ2jRV45Xjy7khrSC6993u2u1Auu/cfTC9Rt7w
LYiee6PiHYiuNyz/DaJPynqy7gDSxS/LOUH0s0UbhUB0SqxJ4k4gzWyfmgSi
nSQ/PnsIpNXldz4H0VUfVu4z0nzluDz2AJjmWCclZAKkLzm5g+mOsO+uIHqt
OqcniN5TJpsGonVfOoPpG6d2cpkB6dKrUTwgurD4xCpbIG1whXk1iI4TDpFa
DaQZigrAdI9XiyKInr5TUAtEb+e5kngRSPNLzUwG0SvlnXaAaHb7JDBtJle6
B0T7/WE9BqLvmmZcBdGruJffBNHpWwvugegjC3Uegmg2hdifIPpgQcQvsDl/
rLcpa71y/OESBqYBReuomA==
  "]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SCSCPRequestEvaluation", "[", "xin_String", "]"}], " ", ":=", " ", 
  
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"expr", ",", " ", "jout"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"expr", " ", "=", " ", 
      RowBox[{"XML2Mathematica", "[", "xin", "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"jout", " ", "=", " ", 
      RowBox[{"OMObject2Java", "[", 
       RowBox[{"Mathematica2OMObject", "[", 
        RowBox[{"Evaluate", "[", "expr", "]"}], "]"}], "]"}]}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51100946081829*^9, 3.511009587145671*^9}, {
   3.511009645236399*^9, 3.511009669845996*^9}, {3.511009781510234*^9, 
   3.511009784951026*^9}, {3.511010219106445*^9, 3.511010228426726*^9}, {
   3.511010415924639*^9, 3.511010503706235*^9}, {3.511010558353998*^9, 
   3.511010565662492*^9}, {3.511017365615319*^9, 3.511017370814859*^9}, {
   3.511017715737236*^9, 3.511017719695859*^9}, {3.511263022954594*^9, 
   3.511263035070968*^9}, {3.511507353685706*^9, 3.511507355724217*^9}, {
   3.511523420824249*^9, 3.511523447326492*^9}, {3.51152362840777*^9, 
   3.511523629162267*^9}, {3.511524075371649*^9, 3.511524100321297*^9}, {
   3.511544104816429*^9, 3.511544169275535*^9}, {3.511544717231336*^9, 
   3.511544717702492*^9}, {3.511581982160504*^9, 3.511582017357335*^9}, {
   3.511582137694167*^9, 3.511582155272114*^9}, {3.511586942421676*^9, 
   3.511586964979531*^9}, 3.511587550933447*^9, {3.511588731129545*^9, 
   3.511588734186172*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SCSCPComputeXMLBlocking", "[", 
    RowBox[{"xml_String", ",", "jclient_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "jin", ",", " ", "jout", ",", " ", "OMTree", ",", "OMWithHeader", ",", 
       " ", "conn"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"SCSCP`Initialized", " ", "\[Equal]", " ", "True"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "ListOfConnections", "]"}]}], ",", " ", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"conn", " ", "=", " ", 
            RowBox[{"ListOfConnections", "[", 
             RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"conn", "[", 
               RowBox[{"[", "1", "]"}], "]"}], " ", "\[Equal]", " ", 
              "jclient"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Print", "[", 
               RowBox[{
               "\"\<Expression \\\"\>\"", "<>", "xml", "<>", 
                "\"\<\\\" is sent to the SCSCP server \>\"", "<>", 
                RowBox[{"conn", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<:\>\"", "<>", 
                RowBox[{"conn", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<.\>\""}], " ", 
               "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"Break", "[", "]"}]}], ",", "\[IndentingNewLine]", 
             "Null"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"OMTree", " ", "=", " ", 
         RowBox[{"XML2OMObject", "[", "xml", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"jin", " ", "=", " ", 
         RowBox[{"OMObject2Java", "[", "OMTree", "]"}]}], ";", "  ", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", "\"\<Waiting for the answer...\>\"", "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"jout", " ", "=", " ", 
         RowBox[{"jclient", "@", 
          RowBox[{"computeBlocking", "[", "jin", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"XML2Mathematica", "[", 
         RowBox[{"jout", "@", 
          RowBox[{"toXml", "[", "]"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
       
       RowBox[{
       "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", 
        "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SCSCPComputeXML", "[", 
   RowBox[{"xml_String", ",", " ", "jclient_"}], "]"}], " ", ":=", " ", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "jin", ",", " ", "OMTree", ",", "OMWithHeader", ",", " ", "conn"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SCSCP`Initialized", " ", "\[Equal]", " ", "True"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", "\[LessEqual]", 
          RowBox[{"Length", "[", "ListOfConnections", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"conn", " ", "=", " ", 
           RowBox[{"ListOfConnections", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"conn", "[", 
              RowBox[{"[", "1", "]"}], "]"}], " ", "\[Equal]", " ", 
             "jclient"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<Expression \\\"\>\"", "<>", "xml", "<>", 
               "\"\<\\\" is sent to the SCSCP server \>\"", "<>", 
               RowBox[{"conn", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "<>", "\"\<:\>\"", "<>", 
               RowBox[{"conn", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "<>", "\"\<.\>\""}], " ", 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"Break", "[", "]"}]}], ",", "\[IndentingNewLine]", 
            "Null"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"OMTree", " ", "=", " ", 
        RowBox[{"XML2OMObject", "[", "xml", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"jin", " ", "=", " ", 
        RowBox[{"OMObject2Java", "[", "OMTree", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"jclient", "@", 
        RowBox[{"compute", "[", "jin", "]"}]}]}], ",", "\[IndentingNewLine]", 
      
      RowBox[{
      "Print", "[", "\"\<The SCSCP package was not initialized!\>\"", "]"}]}],
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533032110036158*^9, 3.533032240801743*^9}, {
  3.53303229095933*^9, 3.533032296739096*^9}, {3.533032341633458*^9, 
  3.533032353141276*^9}, {3.533032449909303*^9, 3.533032455216989*^9}, {
  3.533032493279547*^9, 3.533032567203641*^9}, {3.533032689620857*^9, 
  3.533032695241429*^9}, {3.533034229529703*^9, 3.533034230647318*^9}, {
  3.533035302669218*^9, 3.533035443389181*^9}, {3.533036404004922*^9, 
  3.533036416284242*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{
   "OMObject2Java", ",", " ", "SCSCPInit", ",", " ", "SCSCPConnectionInit", 
    ",", " ", "SCSCPConnectionClose", ",", " ", "SCSCPComputeBlocking", ",", 
    " ", "SCSCPCompute", ",", " ", "SCSCPWait", ",", " ", "SCSCPProbe", ",", 
    " ", "StartSCSCPServer", ",", " ", "SCSCPRequestEvaluation", ",", " ", 
    "SCSCPComputeXMLBlocking", ",", " ", "SCSCPComputeXML"}], "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533032721561171*^9, 3.533032740743789*^9}}],

Cell[BoxData[
 RowBox[{"End", "[", "]"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{"EndPackage", "[", "]"}]], "Input",
 InitializationCell->True]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1398, 750},
WindowMargins->{{1, Automatic}, {Automatic, 51}},
FrontEndVersion->"7.0 for Linux x86 (32-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 1972, 44, 121, "Input",
 InitializationCell->True],
Cell[2520, 66, 171, 3, 32, "Input",
 InitializationCell->True],
Cell[2694, 71, 4895, 94, 467, "Input",
 InitializationCell->True],
Cell[7592, 167, 215, 4, 32, "Input",
 InitializationCell->True],
Cell[7810, 173, 163, 3, 32, "Input",
 InitializationCell->True],
Cell[7976, 178, 167, 3, 32, "Input",
 InitializationCell->True],
Cell[8146, 183, 702, 11, 55, "Input",
 InitializationCell->True],
Cell[8851, 196, 326, 7, 32, "Input",
 InitializationCell->True],
Cell[9180, 205, 1853, 36, 187, "Input",
 InitializationCell->True],
Cell[11036, 243, 1637, 34, 187, "Input",
 InitializationCell->True],
Cell[12676, 279, 2706, 56, 275, "Input",
 InitializationCell->True],
Cell[15385, 337, 570, 13, 32, "Input",
 InitializationCell->True],
Cell[15958, 352, 4234, 118, 341, "Input",
 InitializationCell->True],
Cell[20195, 472, 679, 12, 32, "Input",
 InitializationCell->True],
Cell[20877, 486, 7513, 142, 539, "Input",
 InitializationCell->True],
Cell[28393, 630, 4515, 99, 495, "Input",
 InitializationCell->True],
Cell[32911, 731, 2398, 51, 253, "Input",
 InitializationCell->True],
Cell[35312, 784, 1969, 41, 209, "Input",
 InitializationCell->True],
Cell[37284, 827, 1261, 26, 99, "Input",
 InitializationCell->True],
Cell[38548, 855, 1480, 33, 187, "Input",
 InitializationCell->True],
Cell[40031, 890, 1603, 31, 99, "Input",
 InitializationCell->True],
Cell[41637, 923, 5660, 128, 737, "Input",
 InitializationCell->True],
Cell[47300, 1053, 553, 11, 55, "Input",
 InitializationCell->True],
Cell[47856, 1066, 78, 2, 32, "Input",
 InitializationCell->True],
Cell[47937, 1070, 85, 2, 32, "Input",
 InitializationCell->True]
}
]
*)

(* End of internal cache information *)
